<link rel="import" href="/bower_components/polymer/polymer-element.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">
<link rel="import" href="/bower_components/iron-icons/image-icons.html">

<!--
`<subsystem-app>` is not documented properly yet
-->
<dom-module id="subsystem-app">
  <template>
    <link rel="stylesheet" href="subsystem-app.css?__inline=true">
    <style include="l1page-theme"></style>

    <header>
      <h2>
        [[appData.name]]
        <a href="[[appData.uri]]" target="_blank"><paper-icon-button icon="launch"></paper-icon-button></a>
      </h2>

      <dom-if if=[[_isCritical(appData)]]>
        <template>
          <p critical unhealthy$=[[_isUnhealthy(appData)]]>
            <iron-icon icon="image:flash-on"></iron-icon>
            mandatory application
          </p>
        </template>
      </dom-if>

      <p critical$=[[_isCritical(appData)]] health-message unhealthy$=[[_isUnhealthy(appData)]]>
        <iron-icon icon="[[_healthIcon(appData)]]"></iron-icon>
        [[_healthSummary(appData)]]
      </p>
    </header>

    <dom-if if="[[appData.operations.length]]">
      <template>
        <!-- <h3>Operations</h3> -->
        <dom-repeat items=[[appData.operations]] as=operation>
          <template>
            <!-- <section operation severity$=[[operation.warningLevel]]>
              <h4>[[operation.id]] - [[operation.state]]</h4>
              <p>[[operation.result]]</p>
              <p>[[operation.warningMessage]]</p>
            </section> -->
            <log-entry severity=[[_num2severity(operation.warningLevel)]]
                       title="[[operation.id]]"
                       subtitle="[[operation.state]]"
                       message=[[_getOperationMessage(operation)]]></log-entry>
          </template>
        </dom-repeat>
      </template>
    </dom-if>
    <!-- <dom-if if="[[!appData.operations.length]]">
      <template>
        <p>no operations</p>
      </template>
    </dom-if> -->
    <dom-if if="[[appData.alarms.length]]">
      <template>
        <!-- <h3>Alarms</h3> -->
        <dom-repeat items=[[appData.alarms]] as=alarm>
          <template>
            <log-entry severity=[[alarm.severity]]
                       title=[[appData.name]]
                       subtitle="[[alarm.name]]"
                       message=[[alarm.details]]></log-entry>
          </template>
        </dom-repeat>
      </template>
    </dom-if>
    <!-- <dom-if if="[[!appData.alarms.length]]">
      <template>
        <p>no alarms</p>
      </template>
    </dom-if> -->

    <slot></slot>
  </template>
</dom-module>

<script src="subsystem-app.js?__inline=true"></script>
